// ************************************************************* 
// Programmbeispiel: 	Einlesen des Potentiometers R4 ber ADC 
//						Eingelesener Datenwert steuert Helligkeit des LED-Balken und 7-Segment
//						an Port 4 mit PWM								                           
// Datum: 8.12.2005: mpa										 
//  
                                   

                                  
#include<reg517a.h>
#include<stdio.h>
#include<lcd.h>



// Globale variablen (beginnen mit g...)
char gTXT[25];								// Allgemeiner Textbuffer


// Deklaration der Funktionen
int aduwert(char);

main()
{


int	  adu1;									// Ergebnisse der AD-Umsetzer
float pwmwert;								// pwm in prozent

init_lcd();									// LCD initialisieren
blank_lcd();								// LCD loeschen

											////// Konfigurieren der Compare-Timer-Einheit ///////////////////
CTCON  = 0x03;      						// Einstellen des Vorteilers f=fclk/16
CMSEL  = 0xFF;      						// CM0-CM7 gehrt zu Compare-Timer im PWM modus
CTRELH = 0xFC;     							// Reload wert fr 1024 Stufen = 
CTRELL = 0x00;     							// 65536 - 1024 = 64512 = 0xFC00
CMEN   = 0xFF;								// CM0-CM7 Register freigeben und Ausgang an Powrt P4.1-P4.7  weiterleiten


P6 = 0xFF;									// LE aktivieren mit 11111111. ( P6.7 = LEDBar = 1 , P6.6 = 7Seg = 1)


while(1)										// Endlosschleife
	{
	adu1 = aduwert(10);							// ADU  Kanal 10 lesen 
	pwmwert = (1024.0 - adu1)*100/1024.0;		// Berechnung des Prozentwertes der PWM

	CMH0 = CTRELH + (adu1 >> 8);				// Obere 8 bit extrahieren und zu Reloadwert zuzaehlen	
	CML0 = CTRELL + (0x00FF & adu1);			// Untere 8 bit extrahieren und zu Reloadwert zuzaehlen	
	CMH1 = CMH0;								// Reload Wert kopieren	
	CML1 = CML0;								// Reload Wert kopieren	
	CMH2 = CMH0;								// Reload Wert kopieren	
	CML2 = CML0;								// Reload Wert kopieren	
	CMH3 = CMH0;								// Reload Wert kopieren	
	CML3 = CML0;								// Reload Wert kopieren	
	CMH4 = CMH0;								// Reload Wert kopieren	
	CML4 = CML0;								// Reload Wert kopieren	
	CMH5 = CMH0;								// Reload Wert kopieren	
	CML5 = CML0;								// Reload Wert kopieren	
	CMH6 = CMH0;								// Reload Wert kopieren	
	CML6 = CML0;								// Reload Wert kopieren	
	CMH7 = CMH0;								// Reload Wert kopieren	
	CML7 = CML0;								// Reload Wert kopieren	

	sprintf(gTXT,"PWM=%4.1f Prozent ",pwmwert);	// Messwerte ausgeben
	print_lcd(1,1,gTXT);						// String auf LCD ausgeben. Zeile 1


	warte(100);									// Warte 
	}
}


// Starten einer Analog-Digital-Umsetzung 
// Parameter:	char...Eingabekanal (0-11)
// Rueckgabe:	ADU-Wert int

int aduwert(char kanal)
{
int result;
unsigned int low,high;				// unsigned, damit nicht arithmetisch geschobe wird
ADCON1=kanal;						// ADC Kanal festlegen 0-11
ADDATL = 0;							// Schreibzugriff auf ADDTAL startet Umsetzung
while(BSY)	{;}						// Warte bis BSY Flag Null wird ( Bit 5  in ADCON0 )
low  = ADDATL >> 6;					// ADDATL.7,ADDATL.6 (D1,D0) an Position 1 und 0 schieben
high = ADDATH << 2;					// ADDATH.7 bis ADDATH.0 (D9-D2) an Position 9 bis 2 schieben
result = (int)(high+low);			// Ergebnis zusammensetzen
return(result);
}

